#ifndef _BITS_BASE_HH
#define _BITS_BASE_HH

#include <stdint.h>

template <typename Base = uint32_t>
struct BitArray;

template <typename Base = uint32_t>
struct CudaBitArray;

template <typename Base = uint32_t>
struct KernelBitArray;

template <typename Base>
struct BitArraySiblings {
  typedef BitArray<Base> Host;
  typedef CudaBitArray<Base> Cuda;
  typedef KernelBitArray<Base> Kernel;
};

template <typename Base = uint32_t, typename RankT = uint32_t, size_t Rate = 3>
struct BitRankSL;

template <typename Base = uint32_t, typename RankT = uint32_t, size_t Rate = 3>
struct CudaBitRankSL;

template <typename Base = uint32_t, typename RankT = uint32_t, size_t Rate = 3>
struct KernelBitRankSL;

template <typename Base = uint32_t, typename RankT = uint32_t, size_t Rate = 3>
struct CudaBitRankPacked;

template <typename Base = uint32_t, typename RankT = uint32_t, size_t Rate = 3>
struct KernelBitRankPacked;

template <typename Base, typename RankT, size_t Rate>
struct BitRankSiblings {
  typedef BitRankSL<Base, RankT, Rate> Host;
  typedef CudaBitRankSL<Base, RankT, Rate> Cuda;
  typedef CudaBitRankPacked<Base, RankT, Rate> CudaPacked;
  typedef KernelBitRankSL<Base, RankT, Rate> Kernel;
  typedef KernelBitRankPacked<Base, RankT, Rate> KernelPacked;
};

#endif // _BITS_BASE_HH
