#include <gtest/gtest.h>

#include "bits.hh"


template <class Base, class RankT, size_t Rate, RankT size, size_t iterations>
int bench() {
  int a = 0;
  BitRankSL<Base, RankT, Rate> bits(size);
  for (auto i = 0u; i < size; i += 2)
    bits.Set(i);
  bits.CalculateRanks();
  for (auto j = 0u; j < iterations; ++j)
    for (auto i = 0u; i < size; ++i)
      a += bits.Rank(i);
  return a;
}

TEST(BitRankSL, u16_128)
{
  bench<uint16_t, uint32_t, 8, 1024, 1024*1024>();
}

TEST(BitRankSL, u16_64)
{
  bench<uint16_t, uint32_t, 4, 1024, 1024*1024>();
}

TEST(BitRankSL, u16_32)
{
  bench<uint16_t, uint32_t, 2, 1024, 1024*1024>();
}

TEST(BitRankSL, u16_16)
{
  bench<uint16_t, uint32_t, 1, 1024, 1024*1024>();
}

TEST(BitRankSL, u32_128)
{
  bench<uint32_t, uint32_t, 4, 1024, 1024*1024>();
}

TEST(BitRankSL, u32_64)
{
  bench<uint32_t, uint32_t, 2, 1024, 1024*1024>();
}

TEST(BitRankSL, u32_32)
{
  bench<uint32_t, uint32_t, 1, 1024, 1024*1024>();
}

TEST(BitRankSL, u64_128)
{
  bench<uint64_t, uint32_t, 2, 1024, 1024*1024>();
}

TEST(BitRankSL, u64_64)
{
  bench<uint64_t, uint32_t, 1, 1024, 1024*1024>();
}
