#include <fstream>
#include <string>

#include "util/serialization.hh"
#include "bwt.hh"
#include "dna.hh"
#include "index.hh"

using namespace bmap;

int main(int argc, char * argv[]) {
  std::string bwt_f = argv[1];
  std::string bwt_inl_f = argv[2];

  BWT<DnaMeta> bwt;

  Load(bwt, bwt_f);
  std::ofstream bwtinl(bwt_inl_f);
  bwtinl << bwt.bwt.size << "\n";
  bwtinl << bwt.end_index << "\n";
  for (uint i = 0 ; i < bwt.bwt.size ; ++i) {
    bwtinl << dna::Unmap(bwt.bwt[i]);
    if (i % 10000000 == 0)
      std::cerr << "Done " << i << "/" << bwt.bwt.size << "\n";
  }
}

