#include <fstream>
#include <string>

#include "util/serialization.hh"
#include "bwt.hh"
#include "dna.hh"
#include "index.hh"

using namespace bmap;

int main(int argc, char * argv[]) {
  std::string bwt_inl_f = argv[1];
  std::string bwt_f = argv[2];

  std::ifstream bwtinl(bwt_inl_f);
  uint32_t size, end_index;

  bwtinl >> size;
  bwtinl >> end_index;

  char c;
  bwtinl.get(c);

  BWT<DnaMeta> bwt(size);
  bwt.end_index = end_index;

  for (uint i = 0 ; i < bwt.bwt.size ; ++i) {
    bwtinl.get(c);
    bwt.bwt.Set(i, dna::Map(c));
    if (i % 10000000 == 0)
      std::cerr << "Done " << i << "/" << bwt.bwt.size << "\n";
  }

  Save(bwt, bwt_f);
  return 0;
}

