#ifndef _INDEX_BASE_HH
#define _INDEX_BASE_HH

template <class Index>
struct MatchingResult {
  typedef typename Index::size_type size_type;

  __host__ __device__ MatchingResult() {}
  __host__ __device__ MatchingResult(size_type s, size_type c) : sp(s), count(c) {}

  size_type sp;
  size_type count;
};

template <class Index, size_t max_size>
struct MatchingState {
  typedef typename Index::char_type char_type;
  typedef typename Index::size_type size_type;

  MatchingState() : mapped(0) {}

  size_type sp() const { assert(mapped > 0); return sps[mapped - 1]; }
  size_type ep() const { assert(mapped > 0); return eps[mapped - 1]; }
  MatchingResult<Index> result() const { return MatchingResult<Index>(sp(), count); }

  size_type sps[max_size];
  size_type eps[max_size];
  size_type mapped;
  size_type count;
};

#endif // _INDEX_BASE_HH
