#!/bin/bash

split() {
  str=$1
  for ((i=0;i<${#str};i++)); do
    if [[ $i -gt 0 ]]; then
      echo -n ","
    fi
    echo -n "'${str:$i:1}'"
  done
}

index() {
  name=$1
  type_name=$2
  bitv_base=$3
  bitv_f=$4
  host=$5
  cuda=$6
  srb=$7
  srt=$8
  bitv_name=${bitv_base#uint}
  bitv_name=${bitv_name%_t}
  type_name+="_${bitv_name}_${bitv_f}"
  meta_params="${bitv_base}, ${bitv_f}"
  if [[ -n $srb ]]; then
    type_name+="_${srb}"
    meta_params+=", ${srb}"
  fi
  if [[ -n $srt ]]; then
    type_name+="_${srt}"
    meta_params+=", ${srt}"
  fi

  if [[ $host == 1 ]] ; then
    host="boost::mpl::true_"
  else
    host="boost::mpl::false_"
  fi

  if [[ $cuda == 1 ]] ; then
    cuda="boost::mpl::true_"
  else
    cuda="boost::mpl::false_"
  fi

  echo "$type_name IndexInfo<boost::mpl::string<$(split $type_name)>, $name<DnaMeta<$meta_params> >, $host, $cuda>,"
}

main() {
  for srb in "8" "16" "32" "64"; do
    for srt in "32" "64"; do
      for fact in "1" "2" "4"; do
        index "SSA" "ssa" "uint64_t" "$fact" 1 0 "$srb" "$srt"
      done
    done
  done
  for srb in "8" "16" "32" "64"; do
    for fact in "1" "2" "4"; do
      index "SSAT" "ssat" "uint64_t" "$fact" 1 0 "$srb"
    done
  done
  for srb in "8" "16" "32" "64"; do
    index "SSAT" "cssat" "uint32_t" "3" 1 1 "$srb"
  done
  for fact in "1" "2" "4"; do
    index "SSATS" "ssats" "uint64_t" "$fact" 1 0
  done
}

if [[ -n $1 ]] ; then
  main | cut -d' ' -f1
else
  main | cut -d' ' -f2-
fi
