#include <gtest/gtest.h>

#include "dna.hh"
#include "ssa.hh"
#include "index.hh"

using namespace bmap;
using dna::Map;

using std::string;

SSA<DnaMeta> Build(const std::string & dna)
{
  return BuildSSA(BuildBWT<DnaMeta>(dna::Map(dna)));
}

TEST(SSA, OccRank)
{
  auto ssa(Build("ACGTACAAGTGTGCGCGAGGAGAGAGAGGTG"));
  int a = 0;
  for (int i = 0; i < 100000000; ++i)
    a += ssa.OccRank(i % 4, i % ssa.size);
  EXPECT_TRUE(a > 0);
}
