#ifndef _UTIL_ARRAY_BASE_HH_
#define _UTIL_ARRAY_BASE_HH_

template <typename T>
struct SArray;

template <typename T>
struct CudaArray;

template <typename T>
struct KernelArray;

template <typename T>
struct KernelSizedArray;

template <typename T>
struct ArraySiblings {
  typedef SArray<T> Host;
  typedef CudaArray<T> Cuda;
  typedef KernelArray<T> Kernel;
  typedef KernelSizedArray<T> KernelSized;
};

template <typename T, int BATCH>
struct Array2D;

template <typename T, int BATCH>
struct CudaArray2D;

template <typename T, int BATCH>
struct KernelArray2D;

template <typename T, int BATCH>
struct Array2DSiblings {
  typedef Array2D<T, BATCH> Host;
  typedef CudaArray2D<T, BATCH> Cuda;
  typedef KernelArray2D<T, BATCH> Kernel;
};

#endif // _UTIL_ARRAY_BASE_HH_
