#ifndef _UTIL_COMPACT_BASE_HH_
#define _UTIL_COMPACT_BASE_HH_

template <typename Base, int ElementSize, typename Element = uint8_t>
struct CompactArray;

template <typename Base, int ElementSize, typename Element = uint8_t>
struct CudaCompactArray;

template <typename Base, int ElementSize, typename Element = uint8_t>
struct KernelCompactArray;

template <typename Base, int ElementSize, typename Element>
struct CompactArraySiblings {
  typedef CompactArray<Base, ElementSize, Element> Host;
  typedef CudaCompactArray<Base, ElementSize, Element> Cuda;
  typedef KernelCompactArray<Base, ElementSize, Element> Kernel;
};

#endif // _UTIL_COMPACT_BASE_HH_
