#ifndef _UTIL_SERIALIZATION_HH_
#define _UTIL_SERIALIZATION_HH_

#include <fstream>

#include <boost/archive/binary_oarchive.hpp>
#include <boost/archive/binary_iarchive.hpp>

template <typename T>
void Save(const T & what, const std::string & filename) {
  std::ofstream ofs(filename);
  boost::archive::binary_oarchive oa(ofs);
  oa << what;
}

template <typename T>
void Save(const T & what, std::ostream & ofs) {
  boost::archive::binary_oarchive oa(ofs);
  oa << what;
}

template <typename T>
void Load(T & what, const std::string & filename) {
  std::ifstream ifs(filename);
  boost::archive::binary_iarchive ia(ifs);
  ia >> what;
}

template <typename T>
void Load(T & what, std::istream & ifs) {
  boost::archive::binary_iarchive ia(ifs);
  ia >> what;
}

#endif // _UTIL_SERIALIZATION_HH_
