#ifndef _UTIL_STATIC_FOR_EACH_HH
#define _UTIL_STATIC_FOR_EACH_HH

#include <boost/mpl/next.hpp>

namespace detail {

template <typename Begin, typename End, typename F>
struct static_for_each
{
  static void apply(F & f)
  {
    typedef typename boost::mpl::next<Begin>::type next;
    f.template apply<typename Begin::type>();
    static_for_each<next, End, F>::apply(f);
  }
};

template < typename End, typename F >
struct static_for_each<End, End, F>
{
  static void apply(F & f)
  {
  }
};

}

template <typename Sequence, typename F>
void static_for_each(F & f)
{
  typedef typename boost::mpl::begin<Sequence>::type begin;
  typedef typename boost::mpl::end<Sequence>::type end;

  detail::static_for_each<begin, end, F>::apply(f);
}

#endif // _UTIL_STATIC_FOR_EACH_HH
