#ifndef _UTIL_TIMER_CUDA_HH_
#define _UTIL_TIMER_CUDA_HH_

#include "util/array_cuda.hh"
#include "util/misc.hh"

struct CudaTimer {
    cudaEvent_t start;
    cudaEvent_t stop;
    float total;

    CudaTimer() {
        total = 0;
        cudaEventCreate(&start);
        cudaEventCreate(&stop);
        cudaEventRecord(start);
    }

    ~CudaTimer() {
        cudaEventDestroy(start);
        cudaEventDestroy(stop);
    }

    float time() {
        float time;
        cudaEventRecord(stop, 0);
        cudaEventSynchronize(stop);
        cudaEventElapsedTime(&time, start, stop);
        cudaEventRecord(start);
        total += time;
        return time;
    }
};

#endif // _UTIL_TIMER_CUDA_HH_
